#include "stroj_casu.h"


trie_t * cmd_line_trie;

void help_command(UNUSED char * trash)
{
	printf("help\nexec\nfortune\nfortuneadd\nfortunelist\nfortunedel\nkill\nsavestate\nloadstate\nlcdwrite\nmood\ncommands\ncommandadd\nsetled\nclrled\nblinkled\n");
}

void _parse_command_line_init(void)
{
	// This function has to be called ONLY ONCE and from the global init function
	// It creates the environment for the barbar language parser
	//
	

	const char * known_strings[] = {
		"help", "exec", "fortune", "fortuneadd", "fortunelist", "fortunedel", "kill", "savestate", "loadstate",
		"lcdwrite", "mood", "commandadd", "commands", "setled", "clrled", "blinkled", NULL
	};

	void (* data[])(char *) = {
		&help_command, &loc_exec_command, &fortune, &fortune_add, &fortune_list, &fortune_del, &stop, &save_state, &load_state, &lcd_write, &mood_console,
		&input_command, &show_todo_list, &setled_command, &clrled_command, &blinkled_command, NULL

	};
	
	int i;

	void ( * data_transport)(char *);

	for (i=0;data[i] != NULL;i++)
	{
		data_transport = data[i];
		_add_to_trie(&cmd_line_trie, known_strings[i], (void *) data_transport);
	}

}

int parse_command_line(struct main_file * fi)
{
	int i = 0;
	int j = 0;
	trie_t * now_in;
	now_in = cmd_line_trie;

	int real_length;
	char command_local[LONG_STRING];
	real_length = read(fi->fd, command_local,LONG_STRING);
	command_local[real_length] = 0;
	//DEBUG
	//strcpy(command_local, "exec\n");

	// a cyklime po pismenkach
	while (command_local[i] != 0)
	{
		switch(command_local[i])
		{
			// bily znak
			case 32:
			case 9:
			case 10:
			case 13:
				if (now_in == cmd_line_trie)
				{// na zacatku nebo po jinem bilem znaku ho polkneme
					i++;
					continue;
				}
				if (now_in->data == NULL)
				{// konec slova, ale toto slovo nezname -> chyba
					printf("unknown command\n");
					return 0;
				}
				// konec slova, ktere tu smi byt
				(*((void (*)(char *))now_in->data))(command_local + i + 1);
				return 0;
			// jine pismeno
			default:
				// neni pismeno
				if (command_local[i] - 97 < 0)
					break;
				if (command_local[i] - 97 >= 26)
					break;
				// neplatne slovo
				if (now_in->child[command_local[i] - 97] == NULL)
				{
					printf("unknown command\n");
					return 0;
				}
				// zatim stale platne slovo
				now_in = now_in->child[command_local[i] - 97];


		}
		i++;
	}
	// pokus o provedeni prikazu
	return 0;
}
	
