typedef struct plannedtask {
	char * command;
	s64 time;
} plannedtask_t;

void state_init(void);
void input_command(char * command);
void show_todo_list(UNUSED char * trash);
void loc_exec_command(UNUSED char * buf);

void set_next_move(s64 timestamp); // standard UNIX timestamp
s64 get_next_move(void);
void move_in_time(void);

int get_planned_tasks_count(void);
plannedtask_t * get_planned_task(int no);
int planned_tasks_add(s64 timestamp, char * command);
// returns the ID of that planned task -- it shouldn't change for the whole lifetime of the task 
void planned_tasks_replace(int no, s64 timestamp, char * command);
void planned_tasks_del(int no);
void planned_tasks_check(struct main_timer * timer);
void planned_tasks_update(void);

void fortune(UNUSED char * buf);
void fortune_add(char * buf);
void fortune_del(char * buf);
void fortune_list(UNUSED char * buf);
void _fortune_init(void);

void weather(s64 when); // given an absolute timestamp it prints the weather everywhere it can; for a weather forecast right now simply call weather(stroj_now);

void play_sound(char * path);
void stop_sound(void);

int please(void);
int noplease(void);

void stop(UNUSED char * trash);

void mood_console(char * input);

void _add_to_trie(trie_t ** trie, char * string, void * data);

#define STROJ_TO_REAL_TIME(x)	((x) - stroj_offset)
#define REAL_TO_STROJ_TIME(x)	(stroj_offset + (x))
